#!/usr/bin/python
# Nom de fichier : trame.py


import os, socket, sys, time

from math import *

class Jeu:
	def __init__ (self,name):
		self.name = name
		Jeu.findujeu = False
	def Presentation(self):
		print 'Salut ! Bienvenue dans les', self.name
 

class Joueur:
	'''Represente un PJ avec un nom'''

	population = 0
	position = 0,0
	port = 50000

	def __init__ (self, name, ip):
		'''Initialisation'''
		self.name = name
		self.host = ip
		Joueur.derposX = 0
		Joueur.derposY = 0
		print 'Naissance de {0}'.format(self.name)

		# Quand un joueur est cree, le Joueur est ajoute a la population
		Joueur.population += 1

		#creation du socket et liaison a l adresse ip 
		Joueur.mySocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		try:
			Joueur.mySocket.bind((self.host, Joueur.port))
		except socket.error:
			print "La liaison du socket a l'adresse choisie a echoue."
			sys.exit()

	def __del__ (self):
		'''Je meurs'''
		print '{0} est detruit !'.format(self.name)

		Joueur.population -= 1

		if Joueur.population == 0:
			print '{0} etait le dernier. Fin du jeu.'.format(self.name)
		else:
			print 'Il y a encore {0:d} joueur(s) dans le jeu'.format(Joueur.population)

	def salut(self):
		'''Bonjour du Joueur
		Presentation des regles du jeu'''

		print 'Bonjour, je m\'appelle {0}. Je serai ton guide parmi dans cet Espace.'.format(self.name)

	def position(self):
		'''Recuperation de la position par le GPS'''
		return  31,12

	def danszone(self, typ, ligne):
		'''Verification de la presence d objet ou d action'''
		res = False
		if (typ == 'action'):
			ident, label, coord, description, utilisateur, priorite, dureedevie, action = ligne.split(';')
			centreX, centreY, rayon = coord.split(',')
			print 'centreX {0} ; centreY {1} ; rayon {2}'.format(centreX, centreY, rayon)
			if (((posX - int(centreX))**2 + (posY - int(centreY))**2) < rayon):
				res = True
		if (typ == 'objet'):
			ident, label, coord, description, volume, actif, action, typdobjet = ligne.split(';')
			objX, objY, rayon = coord.split(',')
			if (distance(int(objX),int(objY),posX,posY) < 2):
				res = True

		return res

	def action(self, lignes):
		'''Execute les action
		os.system(action)'''
		print lignes
	
	def agitsurobjet(self, lignes):
		'''Propose des actions sur les objets'''
		print lignes

	def interaction(self):
		print 'Un joueur est dans votre champ d\'action'


	@staticmethod
	def combien():
		'''Affiche le nombre de joueurs'''
		print 'Il y a {0:d} joueur(s) en ce moment'.format(Joueur.population)


class Exception_pasdenom(Exception):
	''' une chaine de caractere trop courte'''
	def __init__ (self, length,atleast):
		Exception.__init__(self)
		self.length = length
		self.atleast = atleast

def joueurdanszone():
	# connection serveur client - partie serveur
	while 1:
		# 3) Attente de la requete de connexion d'un client :
		print "Serveur pret, en attente de requetes ..."
		joueur1.mySocket.listen(5)

		# 4) Etablissement de la connexion :
		connexion, adresse = joueur1.mySocket.accept()
		print "Client connecte, adresse IP %s, port %s" % (adresse[0], adresse[1])

		# 5) Dialogue avec le client :
		connexion.send("Vous etes connecte au serveur Marcel. Envoyez vos messages.")
		msgClient = connexion.recv(1024)
		while 1:
			print "C>", msgClient
			if msgClient.upper() == "FIN" or msgClient =="":
				break
			msgServeur = raw_input("S> ")
			connexion.send(msgServeur)
			msgClient = connexion.recv(1024)

		# 6) Fermeture de la connexion :
		connexion.send("Au revoir !")
		print "Connexion interrompue."
		connexion.close()

		ch = raw_input("<R>ecommencer <T>erminer ? ")
		if ch.upper() =='T':
			break

	return False

def distance(x1,y1,x2,y2):
	return sqrt((x1-x2)**2 + (y1-y2)**2)

def connection():
	'''verifie connection internet ou intranet '''
	return False

def synchronise():
	'''charge un nouveau fichier actions.txt'''
	print 'synchonisation'

def existe(fname):
    try:
        f = open(fname,'r')
        f.close()
        return 1
    except:
        return 0


'''
'	 MAIN 
'	 
'''

j = Jeu('Espaces Enchevetres')
j.Presentation()


try:
	quelqun = raw_input('\nChoisissez un nom pour votre conscience numerique : ')
	if len(quelqun) < 3:
		raise Exception_pasdenom(len(quelqun),3)
except EOFError:
	print('Pourquoi m\'avez-vous envoye une fin de fichier ?')
except Exception_pasdenom as ex:
	print('Exception_pasdenom : La saisie avait une longueur de {0}, et on attendait au moins {1}'.format(ex.length, ex.atleast))
else:
	print('Vous avez saisi {0}'.format(quelqun))
finally:
	quelqun = 'toto'

joueur1 = Joueur(quelqun,'192.168.1.250')
joueur1.salut()
Joueur.combien()

while True:

	print 'Recuperation de la position du joueur'
	posX, posY = joueur1.position()

	if connection():
		synchronise()
		
	if joueurdanszone():
		joueur1.interaction()

	actionsafaire = []
	objetstrouves = []

	if (distance(joueur1.derposX,joueur1.derposY,posX,posY) > 2):
		'''la position a change significativement'''
		joueur1.derposX = posX
		joueur1.derposY = posY
	
		print 'Verification des interactions possibles dans la zone'
		if existe('actions.txt'):
			with open('actions.txt') as a:
				for ligneA in a:
					if joueur1.danszone('action',ligneA):
						actionsafaire.append(ligneA)
		else:
			print 'Probleme a l\'ouverture du fichier actions.txt. Existe-t-il ?'
		joueur1.action(actionsafaire)

		print 'Verification des objets de la zone'
		if existe('objets.txt'):
			with open('objets.txt') as o:
				for ligneO in o:
					if joueur1.danszone('objet',ligneO):
						objetstrouves.append(ligneO)
		else:
			print 'Probleme a l\'ouverture du fichier objets.txt. Existe-t-il ?'
		joueur1.agitsurobjet(objetstrouves)


	if j.findujeu:
		break

	j.findujeu = True

del joueur1
Joueur.combien()
